/*
Copyright (C) 2019 RRe36

All Rights Reserved unless otherwise explicitly stated.


By downloading this you have agreed to the license and terms of use.
These can be found inside the included license-file or here: https://rre36.github.io/kappa_shader_web/license/

Violating these terms may be penalized with actions according to the Digital Millennium Copyright Act (DMCA), the Information Society Directive and/or similar laws depending on your country.
*/


float get_diffLambert(vec3 normal) {
    float lamb  = dot(normal, lightvec);    //Where is the lamb SAUCE?
        lamb    = saturate(lamb);
    return lamb;
}
/*
float get_diffBurley(vec3 normal, vec3 viewvec, vec3 lvec, float roughness, bool foliage) {

    vec3 h  = normalize(viewvec + lvec);

    float nDotL     = saturate(dot(normal, lvec));
    if (foliage) nDotL = nDotL * 0.6 + 0.4;
    float lDotH     = saturate(dot(lvec, h));
    float nDotV     = saturate(dot(normal, viewvec));

    float energy_f  = -roughness * 0.337748344 + 1.0;
    float f90       = 2.0 * roughness * (pow2(lDotH) + 0.25) - 1.0;

    float lscatter  = f90 * pow5(1.0-nDotL) + 1.0;
    float vscatter  = f90 * pow5(1.0-nDotV) + 1.0;

    return nDotL * energy_f * lscatter * vscatter;
}*/

float get_diffOrenNayar(vec3 normal, vec3 viewvec, vec3 lvec, float roughness) {    //qualitative model

    vec3 h  = normalize(viewvec + lvec);

    float nDotL     = saturate(dot(normal, lvec));

    float nDotV     = saturate(dot(normal, viewvec));

    float t     = max(nDotL, nDotV);
    float g     = max(dot(viewvec-normal*nDotV, lvec-normal*nDotL), 0.0);
    float c     = g*rcp(t) - g*t;
    float a     = 0.285 * rcp(roughness + 0.57) + 0.5;
    float b     = 0.45 * roughness * rcp(roughness + 0.09);

    float on    = max(nDotL, 0.0) * (b * c + a);

    return max(on, 0.0);
}