/*
Copyright (C) 2019 RRe36

All Rights Reserved unless otherwise explicitly stated.


By downloading this you have agreed to the license and terms of use.
These can be found inside the included license-file or here: https://rre36.github.io/kappa_shader_web/license/

Violating these terms may be penalized with actions according to the Digital Millennium Copyright Act (DMCA), the Information Society Directive and/or similar laws depending on your country.
*/


/* ------ atmosphere ------ */
#define sun_size 1.0    //[0.1 0.2 0.3 0.4 0.5 0.75 1.0 1.25 1.5 1.75 2.0 2.5 3.0 3.5 4.0 5.0 6.0 7.0 8.0 9.0 10.0]
#define sky_hq_lookup
#define atmos_refract
//#define sun_transmittance_hq

    /* ------ cloud settings ------ */
    #define vcloud_enabled
    #define vcloud_alt 2000.0   //[500.0 1000.0 1500.0 2000.0 2500.0 3000.0]
    #define vcloud_depth 6000.0 //[2000.0 3000.0 4000.0 5000.0 6000.0 7000.0 8000.0 9000.0 10000.0]
    #define vcloud_samples 40   //[20 30 40 50 60 70 80 90 100]
    #define vcloud_clip 90000.0
    //#define vcloud_shapeq 1     //[0 1]
    //#define vcloud_gauss

    #define pcloud_enabled
    #define pcloud_alt  14000.0 //[10000.0 12000.0 14000.0 16000.0 18000.0 20000.0]
    #define pcloud_depth 2500.0 //[1000.0 1500.0 2000.0 2500.0 3000.0 3500.0 4000.0]
    #define pcloud_clip 180000.0

    #if (defined vcloud_enabled || defined pcloud_enabled)
        #define cloud_ssgr_enabled
    #endif
    #define cloud_ssgr_samples 12  //[2 4 6 8 10 12 14 16]
    #define cloud_ssgr_length 1.0 //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0]
    #define cloud_ssgr_density 1.0 //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0]

    /* ------ fog settings ------ */
    #define vfog_enabled
    #define vfog_mist_enabled
    #define vfog_quality 1.0    //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0]
    #define vfog_density 1.0    //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0 2.5 3.0 3.5 4.0 5.0 6.0 7.0 8.0 10.0 12.0 14.0]

    #ifdef vfog_enabled
        #define vfog_translucents
    #endif

    #define vfog_bilateral

    #define vwater_enabled
    #define vwater_quality 1.0  //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0]
    #define vwater_bilateral
    #define vwater_caustic
    #define vwater_density 1.0    //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0 2.5 3.0 3.5 4.0 5.0 6.0 7.0 8.0 10.0 12.0 14.0]


/* ------ lighting settings ------ */
#define shadow_mode 2       //[0 1 2]
#define shadow_vps_iterations 6     //[4 5 6 7 8 9 10]

//#define lightleak_workaround
#define minlight_luma 0.2   //[0.1 0.2 0.3 0.4 0.5 0.75 1.0 1.25 1.5 1.75 2.0 2.5 3.0 3.5 4.0 5.0 6.0 7.0 8.0 9.0 10.0]

    /* ------ effects settings ------ */
    #define ambientOcclusion_enabled
    #define rsm_enabled
    #define rsm_steps 24        //[4 8 16 24 32 48 64]
    #define rsm_size 60.0       //[20.0 40.0 60.0 80.0 100.0]
    #define rsm_spatial_dualpass
    #define subsurface_enabled


/* ------ world settings ------ */
//#define labpbr_enabled
//#define normalmap_enabled
#define normalmap_format 0      //[0 1]0-lab 1.2, 1-lab1.1

    /* ------ pom settings ------ */
    //#define pom_enabled
    #define pom_iterations 32       //[8 16 32 64 96 128 192 256 384 512]
    #define pom_depth 1.0           //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define pom_shadows_enabled
    #define pom_shadow_iterations 8 //[2 4 8 16 32 64 96 128]   

    /* ------ reflection settings ------ */
    #define reflections_enabled

    #ifdef reflections_enabled
        #define ssr_enabled
        #define cloud_reflections_enabled
    #endif
    #define rough_reflections_enabled

    /* ------ water settings ------ */
    //#define water_normal_hq
    #define water_normal_octaves 4  //[2 3 4 5 6 7 8]
    #define water_caustic
    #define water_refraction
    #define water_parallax_enabled
    #define water_parallax_steps 6  //[3 4 5 6 7 8 9]

    #define custom_water
    #define custom_ice

#define wind_effects_enabled
#define wind_intensity 1.0  //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]


/* ------ post settings ------ */
#define taa_enabled
#define purkinje_sensitivity 1.0    //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
//#define upscale_sharpen

    /* ------ exposure settings ------ */
    #define exposure_minlum 1.0     //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.2 1.4 1.6 1.8 2.0 2.2. 2.4 2.6 2.8 3.0 3.5 4.0 5.0 6.0 8.0 10.0 15.0 20.0]
    #define exposure_speed 1.0      //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0 2.5 3.0 4.0]
    //#define manual_exposure_enabled
    #define manual_exposure 14.0     //[0.1 0.3 0.5 1.0 1.5 2.0 3.0 4.0 5.0 6.0 7.0 8.0 9.0 10.0 12.0 14.0 16.0 18.0 20.0 25.0 30.0 40.0 50.0]

    /* ------ camera settings ------ */
    #define bloom_enabled
    #define bloom_intensity 1.0     //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]

    #define motionblur_enabled
    #define motionblur_samples 8    //[4 6 8 10 12 14 16]
    #define motionblur_size 1.0     //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]

    /* ------ color grading settings ------ */
    //#define do_colorgrading

    #define vibrance_int 1.0    //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define saturation_int 1.0  //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define gamma_curve 1.0     //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define brightness_int 0.0  //[-0.5 -0.4 -0.3 -0.2 -0.1 0.0 0.1 0.2 0.3 0.4 0.5]
    #define constrast_int 1.0   //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]

    #define colorlum_r 1.0      //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define colorlum_g 1.0      //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]
    #define colorlum_b 1.0      //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]


/* ------ internals ------ */
//#define hide_terrain
#define cloud_atmos_density 1.82e-5

#define SKY_RENDER_LOD 2
#define CLOUD_RENDER_LOD 2.0
#define SKYREF_LOD 3.0

#define DEBUG_VIEW 0    //[0 1 2 3 4] 0-off, 1-whiteworld, 2-ao
